//------------------------------------------------------------------------------
//    : main.c
//      : AT91SAM7S512
//    :  (cycos21@naver.com)
//    : 2007 10 16
//    :
//    :
//      :
//------------------------------------------------------------------------------	

#include <typedef.h>
#include <register.h>
#include <setup.h>

#include <7segment.h>

#define DELAY_TIME 0x200000


//------------------------------------------------------------------------------
//  : LED   Ų.
//------------------------------------------------------------------------------
void leds_init( void )
{
	//	LED ʱȭ
	PIOA_PER  = (LED1|LED2|LED3);
	PIOA_OER  = (LED1|LED2|LED3);
	PIOA_SODR = (LED1|LED2|LED3);
}

//------------------------------------------------------------------------------
//  : LED ON
//------------------------------------------------------------------------------
void led_on( u32 led_value )
{
	PIOA_CODR = led_value;
}

//------------------------------------------------------------------------------
//  : LED OFF
//------------------------------------------------------------------------------
void led_off( u32 led_value )
{
	PIOA_SODR = led_value;
}


//------------------------------------------------------------------------------
//  : LED   Ų.
//------------------------------------------------------------------------------
void led_flash( void )
{
	volatile int lp;

	led_on(LED1|LED2);  for( lp = 0; lp < 0x40000; lp++ ) ;
	led_off(LED1|LED2); for( lp = 0; lp < 0x40000; lp++ ) ;
	led_on(LED1|LED2);  for( lp = 0; lp < 0x40000; lp++ ) ;
	led_off(LED1|LED2); for( lp = 0; lp < 0x40000; lp++ ) ;

}


//------------------------------------------------------------------------------
//  : delayŭ 
//------------------------------------------------------------------------------
void hard_delay(int delay)
{
	volatile int i;
	
	for(i=0; i<delay; i++);
	
}


//------------------------------------------------------------------------------
//  :  ƾ
//------------------------------------------------------------------------------
int main(void)
{
	int index_7seg;
	
	leds_init();			// LEDʱȭ

	SevenSeg_Init();		// 7-Segment ʱȭ

	led_flash();			// LED ׽Ʈ

	index_7seg = 0;
		
	while(1)
	{
	
		u8 val_7seg = Conv_To_7seg(index_7seg++);  //7-Segment ° ȯ 
		Serial_Display(val_7seg); 	//7-Segment 
		
		hard_delay(DELAY_TIME);			// 
						
		if(index_7seg == 16)
		{
			index_7seg = 0;
		}

	
	}//END while
		
	return 0;
}


