//------------------------------------------------------------------------------
// ȭϸ : irq.c
//    : ezload irq ó õ ƾ̴. 
// 
// ۼ : â 
// ۼ : 2007 5 26
// ۱ : 
//    : 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//
//  
//
//------------------------------------------------------------------------------
#include <typedef.h>
#include <register.h>
#include <setup.h>

#include <console.h>
#include <irq.h>
#include <stdio.h>
#include <string.h>

//#define IRQ_MASK		0x00000080
//#define FIQ_MASK		0x00000040
#define IRQ_MASK		0x000000C0

//------------------------------------------------------------------------------
//
//   
//
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//  : ͷƮ ڵ鷯 ϵ ʾ  ó ڵ鷯
//------------------------------------------------------------------------------
RAMFUNC static void irq_none( void )
{
	
}

//------------------------------------------------------------------------------
//  : CPSR  ´.
//------------------------------------------------------------------------------
RAMFUNC static inline u32 __get_cpsr(void)
{
	u32 state;
	asm volatile (" mrs  %0, cpsr" : "=r" (state) : /* no inputs */  );
	return state;
}

//------------------------------------------------------------------------------
//  : CPSR  Ѵ.
//------------------------------------------------------------------------------
RAMFUNC static inline void __set_cpsr( u32 state )
{
	asm volatile (" msr  cpsr, %0" : /* no outputs */ : "r" (state)  );
}

//------------------------------------------------------------------------------
//  : IRQ ͷƮ Ѵ. 
//------------------------------------------------------------------------------
RAMFUNC u32 irq_disable(void)
{
	u32 _cpsr;

	_cpsr = __get_cpsr();
	__set_cpsr(_cpsr | IRQ_MASK);
	return _cpsr;
}


//------------------------------------------------------------------------------
//  :  IRQ ͷƮ · . 
//------------------------------------------------------------------------------
RAMFUNC u32 irq_restore( u32 oldCPSR )
{
	u32 _cpsr;

	_cpsr = __get_cpsr();
	__set_cpsr((_cpsr & ~IRQ_MASK) | (oldCPSR & IRQ_MASK));
	return _cpsr;
}

//------------------------------------------------------------------------------
//  : IRQ ͷƮ 㰡 Ѵ. 
//------------------------------------------------------------------------------
RAMFUNC u32 irq_enable(void)
{
	u32 _cpsr;

	_cpsr = __get_cpsr();
	__set_cpsr(_cpsr & ~IRQ_MASK);
	return _cpsr;
}

//------------------------------------------------------------------------------
//  : IRQ ڵ鷯 Ѵ.
//  : ϵǴ IRQ    켱 ´. 
//------------------------------------------------------------------------------
void irq_request ( u32 irq, u32 type, void (*irq_func ) (void ) )
{
	volatile u32 *AIC_SVRs;
	volatile u32 *AIC_SMRs;
	u32 		  mask;

	AIC_SVRs = &(AIC_SVR);
	AIC_SMRs = &(AIC_SMR);
	
    mask = 0x1 << irq ;

    AIC_IDCR = mask ;							// ͷƮ  
    AIC_SVRs[irq] = (u32) irq_func ;				// ͷƮ  ƾ 
    if(irq == 1)	AIC_SMRs[irq] = type | 7;		// 켱  ͷƮ Ÿ
    else					AIC_SMRs[irq] = type | AIC_PRIOR_HIGHEST;		// 켱  ͷƮ Ÿ

    AIC_ICCR = mask ;							// ͷƮ  Ŭ 
}

//------------------------------------------------------------------------------
//  : IRQ ڵ鷯  Ѵ. 
//------------------------------------------------------------------------------
void irq_free( u32 irq )
{
	volatile u32 *AIC_SVRs;
    u32 		  mask;

	AIC_SVRs = &(AIC_SVR);
    mask = 0x1 << irq ;

    AIC_IDCR = mask ;							// ͷƮ  
    AIC_SVRs[irq] = (u32) irq_none ;				// ͷƮ  ƾ 
    AIC_ICCR = mask ;							// ͷƮ  Ŭ 
}

//------------------------------------------------------------------------------
//  : IRQ ͷƮ ȣ Ȱȭ 
//------------------------------------------------------------------------------
void RAMFUNC irq_active( u32 irq )
{
    AIC_IECR = 0x1 << irq;
}
//------------------------------------------------------------------------------
//  : IRQ ͷƮ ȣ  Ȱȭ
//------------------------------------------------------------------------------
void RAMFUNC irq_deactive( u32 irq )
{
    u32 mask;
    
    mask = 0x1 << irq;
    
    AIC_IDCR = mask ;
    AIC_ICCR = mask ;
}

//*----------------------------------------------------------------------------
//  : IRQ ͷƮ  Ŭ
//*----------------------------------------------------------------------------
void RAMFUNC irq_clear( u32 irq )
{
    AIC_ICCR = (0x1 << irq);
}

//------------------------------------------------------------------------------
//  : IRQ ó ʱȭ Ѵ.
//------------------------------------------------------------------------------
void irq_init( void )
{
	volatile u32 *AIC_SVRs;
	
	int lp;
	
	AIC_SVRs = &(AIC_SVR);
	
	// ƹ͵ ó ʴ ͷƮ ڵ鷯 Լ IRQ ͷƮ ڵ鷯 Ѵ. 
	for(lp=1; lp<31; lp++)
	{
		if(lp!=2)AIC_SVRs[lp] = (u32) irq_none;	//system irq ״ Ѵ.
	}
	AIC_SPU = (u32) irq_none;
	
	irq_enable();
}

