//------------------------------------------------------------------------------
//    : main.c
//      : AT91SAM7S512
//    :  (cycos21@naver.com)
//    : 2007 10 16
//    :
//    :
//      :
//------------------------------------------------------------------------------


#include <typedef.h>
#include <register.h>
#include <setup.h>

#include <irq.h>
#include <timer.h>
#include <main.h>

#include <7segment.h>


//------------------------------------------------------------------------------
//  : LED   Ų.
//------------------------------------------------------------------------------
void leds_init( void )
{
	//	LED ʱȭ
	PIOA_PER  = (LED1|LED2|LED3);
	PIOA_OER  = (LED1|LED2|LED3);
	PIOA_SODR = (LED1|LED2|LED3);
}

void led_on( u32 led_value )
{
	PIOA_CODR = led_value;
}

void led_off( u32 led_value )
{
	PIOA_SODR = led_value;
}

void led_flash( void )
{
	volatile int lp;

	led_on(LED1|LED2);  for( lp = 0; lp < 0x40000; lp++ ) ;
	led_off(LED1|LED2); for( lp = 0; lp < 0x40000; lp++ ) ;
	led_on(LED1|LED2);  for( lp = 0; lp < 0x40000; lp++ ) ;
	led_off(LED1|LED2); for( lp = 0; lp < 0x40000; lp++ ) ;

}


//------------------------------------------------------------------------------
//  :  ƾ
//------------------------------------------------------------------------------
int main(void)
{
	int index_7seg;

	leds_init();			// LEDʱȭ
	irq_init();			// IRQ ͷƮ ó ʱȭ
	timer_init();			// Timer ʱȭ 1msec
	SevenSeg_Init();		// 7-Segmetn ʱȭ

	led_flash();			// LED ׽Ʈ

	index_7seg = 0;
	timer_set_timeover(1000);	// Ÿӿ ð  1
		
	while(1)
	{
		//1ʿ 1 7Segment  
		if(timer_is_timeover()) //Ÿ ð ʰǸ 
		{
			u8 val_7seg = Conv_To_7seg(index_7seg++);  //7-Segment ° ȯ 
			Serial_Display(val_7seg); 		//7-Segment 
			
			if(index_7seg == 16)
			{
				index_7seg = 0;
			}

			timer_set_timeover(1000); // Ÿ̿ ð  1
		}

	}//END while
		
	return 0;
}


