/*==============================================================================================

  ȭϸ : start.S
     : AT91SAM7S256 ½ ȣǴ ƾ

  ۼ : ̸()  â
  ۼ : 2007 4 18
     :
  ۼ :
     :

================================================================================================*/

#include <register.h>
#include <setup.h>

#define 	  	IRQ_STACK_SIZE    	(3*8*4)

#define       	ARM_MODE_FIQ       	0x11
#define       	ARM_MODE_IRQ       	0x12
#define       	ARM_MODE_SVC       	0x13

#define         IRQ_DISABLE      	0x80
#define         FIRQ_DISABLE     	0x40

#define 		I_BIT		0x80
#define 		F_BIT		0x40

.text

//------------------------------------------------------------------------------------------------
//
//  ͷƮ   ̺
//
//------------------------------------------------------------------------------------------------
.globl 		_start

_start:	b	reset		    		// MCU µ ȴ.
		b	undefined_instruction	// ǵ ʴ   νƮͿ ġǾ ȴ.
		b	software_interrupt      // Ʈ ͷƮ (SWI) Ǿ  ȴ.
		b	prefetch_abort			// Ÿ  ġ Ҷ   ߻ϸ ȴ.
		b	data_abort	        	// Ÿ  ߻ϸ ȴ.
		b	not_used	        	//  ʴ´.
		b	IRQ		        		// IRQ ͷƮ ߻Ǹ ȴ.
		b	FIQ						// IRQ ͷƮ 켱 ִ ͷƮ ߻Ǹ ȴ.

//------------------------------------------------------------------------------------------------
//
//  RESET ߻ϰų     ó Ǵ ƾ̴.
//
//------------------------------------------------------------------------------------------------
reset:

		//
		// IRQ/FIQ  𽺿̺ Ű IRQ  ȯѴ.
		//
		mrs		r0, CPSR
		bic		r0, r0, #0x1F
		orr		r0, r0, #( ARM_MODE_IRQ | IRQ_DISABLE | FIRQ_DISABLE )
		msr		CPSR_c, r0

        //
        // IRQ  Ѵ.
        //
		ldr		r1, =ADDR_STACK
		mov		sp,r1

		//
		// IRQ/FIQ  𽺿̺ Ű ۹  ȯѴ.
		//
		mrs		r0, CPSR
		bic		r0, r0, #0x1F
		orr		r0, r0, #( ARM_MODE_SVC | IRQ_DISABLE | FIRQ_DISABLE )
		msr		CPSR_c, r0

        //
        // IRQ  Ѵ.
        //
        sub     r1, r1, #IRQ_STACK_SIZE
		mov		sp,r1

		//
		// ÷ ޸   
		//
		ldr		r0, =(MC_FMCN_VAL|MC_FWS_1FWS)						// ÷ ޸   
		ldr		r1, =MC_FMR                                     	// 30 Ǵ 40 MHz ̻  1 Ŭ ＼
		str		r0, [r1]                                        	//  MCK  47923200 (MC_FMCN_VAL = 48) ̸ 1 ũ  50 Ŭ .

		//
		// ġ 
		//
		ldr		r0, =(WDTC_WDDIS)									// ġ 
		ldr		r1, =WDTC_WDMR
		str		r0, [r1]

		//
		// MCK Ŭ 47.923200 MHz 
		//
		ldr		r0, =(CKGR_OSCOUNT_VAL|CKGR_MOSCEN)					// MCK Ŭ 47.923200 MHz 
		ldr		r1, =PMC_MOR                                    	//  Ƿ ̳̺
		str		r0, [r1]                                        	// SCK = 1/32768 = 30.51 ũ
    	                                                        	// ŸƮ Ÿ = 8 * 6 / SCK = 56 * 30.51 = 1,46484375 ̸

		ldr		r1, =PMC_SR											//  OSC ÿ  ȭ  
wait_osc_stable:
		ldr		r0,[r1]
		ands	r0,r0,#PMC_MOSCS
        beq		wait_osc_stable

		//
		// PLL  ֺ 
		//
		ldr		r0, =(CKGR_DIV_VAL|CKGR_PLLCOUNT_VAL|CKGR_MUL_VAL)    // PLL  ֺ 
		ldr		r1, =PMC_PLLR                                         // - div by 5 Fin = 3,6864 =(18,432 / 5)
		str		r0, [r1]                                              // - Mul 25+1: Fout =	95,8464 =(3,6864 *26)
                                                                      // 96 MHz    0.16%
                                                                      // Field out NOT USED = 0
                                                                      // PLLCOUNT pll startup time estimate at : 0.844 ms
                                                                      // PLLCOUNT 28 = 0.000844 /(1/32768)

		ldr		r1, =PMC_SR											  // PLL LOCK   ȭ  
wait_lock_stable:
		ldr		r0,[r1]
		ands	r0,r0,#PMC_LOCK
        beq		wait_lock_stable

		ldr		r1, =PMC_SR											// MCK   ȭ  ⸦  Ѵ.
wait_mck_stable1:
		ldr		r0,[r1]
		ands	r0,r0,#PMC_MCKRDY
        beq		wait_mck_stable1

		//
		// PLL Ŭ 2 
		//
		ldr		r0, =(PMC_PRES_CLK_2)								// PLL Ŭ 2 
		ldr		r1, =PMC_MCKR
		str		r0, [r1]

		ldr		r1, =PMC_SR											// MCK   ȭ  
wait_mck_stable2:
		ldr		r0,[r1]
		ands	r0,r0,#PMC_MCKRDY
        beq		wait_mck_stable2

		//
		// PCK   Ŭ 
		//
		ldr		r0, =(PMC_PRES_CLK_2|PMC_CSS_PLL_CLK)				// PCK   Ŭ 
		ldr		r1, =PMC_MCKR
		str		r0, [r1]

		ldr		r1, =PMC_SR											// MCK   ȭ  ⸦  Ѵ.
wait_mck_stable3:
		ldr		r0,[r1]
		ands	r0,r0,#PMC_MCKRDY
        beq		wait_mck_stable3

        //
        // C α׷ ʱȭ Ͱ ִ  ( .data ) ҿ  Ѵ.
        //
		ldr		r1,	=_data_read_start
        ldr		r2, =_data_write_start
        ldr     r3, =_data_write_end
realloc_data_loop:
		cmp     r2,r3
        ldrlo   r0, [r1], #4
        strlo   r0, [r2], #4
        blo     realloc_data_loop

		//
		// C α׷  ʱȭ Ͱ ִ  (.bss) Ŭ Ѵ.
		//
        mov		r0,#0
		ldr		r1,=_bss_start
		ldr		r2,=_bss_end
bss_clear_loop:
		cmp    r1, r2
        strlo   r0, [r1], #4
        blo     bss_clear_loop

//		//
//		// IRQ ͷƮ 㰡 Ѵ.
//		//
//		mrs		r0, CPSR
//		bic		r0, r0, #0x1F
//		orr		r0, r0, #( ARM_MODE_SVC | FIRQ_DISABLE )
//		msr		CPSR_c, r0

		//
		// C main Լ ̵Ѵ.
		//

		ldr		lr,=exit
		ldr		r0,=main
		bx		r0

		//
		//   ȵȴ.
		//

exit:
        b    .

//------------------------------------------------------------------------------------------------
//  IRQ ͷƮ ó
//------------------------------------------------------------------------------------------------
IRQ:
		sub         lr, lr, #4							// ͷƮ ó   ּҸ ÿ Ѵ.
		stmfd       sp!, {lr}							// Ŀ lr  r14 ͸ Ƿ 밡ϴ.

		mrs         r14, SPSR							// ͷƮ ó  ؾ  ¸ ÿ Ѵ.
		stmfd       sp!, {r14}

		stmfd       sp!, {r0}							// r0 ͸ ϱ ؼ r0 ͸ ÿ Ѵ.

//		mrs		r0, CPSR								// ͷƮ 㰡  Ű IRQ 忡 ۹  ȯѴ.
//		bic		r0, r0, #0x1F							//   Ŀ  ۹  Ѵ.
//		orr		r0, r0, #( ARM_MODE_SVC | IRQ_DISABLE | FIRQ_DISABLE )
//		msr		CPSR_c, r0

		ldr         r14, =AIC_IVR						//  ͷƮ  ڵ鷯 ּҸ r0  Ѵ.
		ldr         r0 , [r14]
		str         r14, [r14]							// <--  ƾ  ʿ? ΰ?


		msr         CPSR_c, #( ARM_MODE_SVC )

		stmfd       sp!, { r1-r3, r12, r14}				//  ͸ ÿ Ѵ.

		mov         r14, pc								// ̰  ʿ?
		bx          r0									// ͷƮ  ƾ Ѵ.

		ldmia       sp!, { r1-r3, r12, r14}				// ÿ Ǿ    Ѵ.

//		mrs		r0, CPSR								// ͷƮ Ȱȭ Ű ۹ 忡 IRQ  ȯѴ.
//		bic		r0, r0, #0x1F							//   Ŀ  ۹  Ѵ.
//		orr		r0, r0, #( ARM_MODE_IRQ | IRQ_DISABLE | FIRQ_DISABLE )
//		msr		CPSR_c, r0

		msr         CPSR_c, #(IRQ_DISABLE | ARM_MODE_IRQ)

		ldr         r14, =AIC_EOICR						// ͷƮ  Ǿ ˸.
		str         r14, [r14]

		ldmia       sp!, {r0}							// R0   Ѵ.

		ldmia       sp!, {r14}							// SPSR  Ѵ. ü (C,X,S,F) 
		msr         SPSR_cxsf, r14

		ldmia       sp!, {pc}^							// ͷƮ  ġ Ѵ.

//		ldr		r3, =(LED2|LED3)
//		b		error_led

//------------------------------------------------------------------------------------------------
//  Reset,IRQ ̿ ͷƮ ó
//------------------------------------------------------------------------------------------------
data_abort:
		ldr		r3, =(LED1)
		b		error_led

undefined_instruction:
		ldr		r3, =(LED2)
		b		error_led

software_interrupt:
		ldr		r3, =(LED1|LED2)
		b		error_led

prefetch_abort:
		ldr		r3, =(LED3)
		b		error_led

not_used:
		ldr		r3, =(LED1|LED3)
		b		error_led


FIQ:
//FIQ_Handler_Entry:
//;- Switch in SVC/User Mode to allow User Stack access for C code 
//; because the FIQ is not yet acknowledged

//;- Save and r0 in FIQ_Register 
            mov         r9,r0
            mov			  r8, #0
            ldr           r0 , [r8, #AIC_FVR]
		     	//ldr           r0 , [r8, #AIC_SVR]
            msr         CPSR_c,#I_BIT | F_BIT | ARM_MODE_SVC
		
//;- Save scratch/used registers and LR in User Stack
            stmfd       sp!, { r1-r3, r12, lr}

//;- Branch to the routine pointed by the AIC_FVR
            mov         r14, pc
	        bx           r0

//;- Restore scratch/used registers and LR from User Stack
            ldmia       sp!, { r1-r3, r12, lr}

//;- Leave Interrupts disabled and switch back in FIQ mode
            msr         CPSR_c, #I_BIT | F_BIT | ARM_MODE_FIQ

//;- Restore the R0 ARM_MODE_SVC register 
            mov         r0,r9

//;- Restore the Program Counter using the LR_fiq directly in the PC
			
            subs        pc,lr,#4


error_led:

		//	LED ʱȭ
		ldr		r1, =(LED1|LED2|LED3)
		ldr		r0, =PIOA_PER
		str		r1, [r0]

		ldr		r0, =PIOA_OER
		str		r1, [r0]

		ldr		r0, =PIOA_SODR
		str		r1, [r0]

error_led3:
		ldr		r1, =(LED1|LED2|LED3)

		// LED 
		ldr		r0, =PIOA_SODR  //OFF
		str		r1, [r0]

		ldr     r2,=0x80000		//off delay time
error_led1:
		subs    r2,r2,#1
		bne     error_led1

		ldr		r0, =PIOA_CODR
		str		r3, [r0]				//ON

		ldr     r2,=0x400000	//on delay time
error_led2:
		subs    r2,r2,#1
		bne     error_led2	

		b		error_led3

