//------------------------------------------------------------------------------
// ȭϸ : timer.c
//    : ezload Timer  ƾ̴. 
// 
// ۼ : â ̸() frog@falinux.com
// ۼ : 2007 6 16
//    : 
//------------------------------------------------------------------------------

//******************************************************************************
//
//  
//
//******************************************************************************
#include <typedef.h>
#include <register.h>
#include <setup.h>
#include <irq.h>
#include <timer.h>
#include <main.h>

#include <stdio.h>

#define PCLK  				(47923200)
#define TICKS_PER_MSECOND	(PCLK/1024/1000)

//******************************************************************************
//   
//******************************************************************************

u32 random_seed    = 0;	//  ߻   
u32 mticks  	   = 0;	// 1mSec   ϴ ƽ
u32 time_over_end  = 0;	// ð ʰ ϱ  

//******************************************************************************
//   
//******************************************************************************



//******************************************************************************
// Լ 
//******************************************************************************

//------------------------------------------------------------------------------
//  :1m Sec  ϴ Ÿ̸ ͷƮ ڵ鷯
// Ű :  
// ȯ :  
//  :  
//------------------------------------------------------------------------------
void timer_irq_handler( void )
{
	unsigned int dummy;

	dummy = TC0_SR;		// Ÿ̸ ͷƮ Ŭ
	dummy = dummy;

	mticks++;
	
}

//------------------------------------------------------------------------------
//  : Ÿ̸Ӹ ʱȭ Ѵ. 
// Ű :  
// ȯ :  
//  :  
//------------------------------------------------------------------------------
void timer_init(void)
{
	u32 dummy;

	random_seed    = 0;
	mticks         = 0;	    				// 1mSec   ϴ ƽ
	time_over_end  = 0;	         			// 1mSec   ϴ ƽ

	PMC_PCER = 1 << ID_TC0;    				// Ÿ̸ Ŭ  Ų.

	TC0_CCR = TC_CLKDIS;					// Ŭ ͷƮ  Ų.
	TC0_IDR = 0xFFFFFFFF ;

	dummy = TC0_SR;						 	//  Ʈ Ŭ Ѵ.
	
	TC0_CMR = TC_CLKS_TIMER_DIV5_CLOCK | TC_CPCTRG | TC_WAVE | TC_EEVT_XC0;
//	TC0_RC  = 0x8FF;
	TC0_RC  = TICKS_PER_MSECOND;

//	TC0_CMR = TC_CLKS_TIMER_DIV5_CLOCK;   	// Ÿ̸ īƮ 带 Ѵ.
	TC0_CCR = TC_CLKEN ;					// Ŭ ۽Ų.
	TC0_IER = TC_CPCS;  					// Ÿ̸ ͷƮ 㰡 CPC 

	irq_request( ID_TC0, AIC_SRCTYPE_INT_HIGH_LEVEL, timer_irq_handler ); // ͷƮ ڵ鷯 
	irq_active( ID_TC0 );                   // Ÿ̸ ͷƮ 㰡

	TC0_CCR = TC_SWTRG ;					// Ÿ̸  

	dummy = dummy;							// dummy    ʾҴٴ   ϱ  
	
//	printf( "TIMER TICK = %d\n",  );
}

//------------------------------------------------------------------------------
//  :  ð m    ش.
// Ű :  
// ȯ :  
//  :  
//------------------------------------------------------------------------------
u32 timer_msec(void)
{
	u32 old_flag;
	u32 ret_msec;

	old_flag = irq_disable();
	ret_msec = mticks;
	irq_restore( old_flag );
	
	return ret_msec;	
}

//------------------------------------------------------------------------------
//  :  ð    ش.
// Ű :  
// ȯ :  
//  :  
//------------------------------------------------------------------------------
u32 timer_sec(void)
{
	return mticks / 1000;	
}

//------------------------------------------------------------------------------
//  :  ȯѴ.
// Ű :  
// ȯ :  
//  :  
//------------------------------------------------------------------------------
u32 timer_random( void )
{
	unsigned long next;
  	unsigned long result;

	if( random_seed == 0 ) random_seed = (unsigned long ) timer_msec();
	next = random_seed;

  	next *= 1103515245;
  	next += 12345;
  	result = (unsigned int) (next / 65536) % 2048;

  	next *= 1103515245;
  	next += 12345;
  	result <<= 10;
  	result ^= (unsigned int) (next / 65536) % 1024;

  	next *= 1103515245;
  	next += 12345;
  	result <<= 10;
  	result ^= (unsigned int) (next / 65536) % 1024;

  	random_seed = next;

  	return result;
}

//------------------------------------------------------------------------------
//  : и    ´.
// Ű :  
// ȯ :  
//  : ???ms ̻   ʴ´.
//------------------------------------------------------------------------------
void mdelay(u32 msec)
{
	u32 end_msec;
	u32 cur_msec;

	cur_msec = timer_msec();
	end_msec = cur_msec + msec;

	while( 1 )
	{
		cur_msec = timer_msec();
		if( cur_msec >= end_msec ) break;
	}
}

//------------------------------------------------------------------------------
//  : ʰ ð Ѵ.
// Ű : msec :  ̸  ð
//------------------------------------------------------------------------------
void timer_set_timeover( u32 msec )
{
	time_over_end = timer_msec();
	time_over_end = time_over_end + msec;
}

//------------------------------------------------------------------------------
//  :  ð ʰ ߻ߴ° ȮѴ. 
// ȯ : Ÿӿ= 1,  = 0
//  : 
//------------------------------------------------------------------------------
u32   timer_is_timeover( void )
{
	u32 cur_msec;

	cur_msec = timer_msec();
	if( cur_msec < time_over_end ) return 0;
	return 1;
}

