//------------------------------------------------------------------------------
//    : console.c
// Ʈ : ez-jtag
//      : ֿܼ ø ó 
//    : â(frog@falinux.com)
//    : 2007 5 6
//    : 
//    : 
//      : 
// ̼ : BSD
//------------------------------------------------------------------------------
#include <typedef.h>
#include <register.h>
#include <setup.h>
#include <irq.h>

#include <console.h>

#include <etk.h>

#define RX_QUEUE_SIZE   (256)
#define RX_QUEUE_MASK    0xFF
//------------------------------------------------------------------------------
//   
//------------------------------------------------------------------------------
static u8    rxq_buff[RX_QUEUE_SIZE];
static u32   rxq_head;
static u32   rxq_tail;

//------------------------------------------------------------------------------
//  : ܼ ġ  ͷƮ ڵ鷯
//------------------------------------------------------------------------------
void console_irq_handler(void )
{
	u8 c;
	
	c = DBGU_RHR;
	rxq_buff[rxq_head] = c;
	rxq_head++;
	rxq_head &= RX_QUEUE_MASK;
	
}

//------------------------------------------------------------------------------
//  : ܼ ġ ʱȭ Ѵ. 
// Ű : baudrate : ۼӵ
//  :  ׻ none parity, 8 bit data, 1 stop ̴. 
//------------------------------------------------------------------------------
void console_init( u32 baudrate )
{
	u32	baud_value;

	// rx ť   ʱȭ 
	rxq_head  = 0;
	rxq_tail  = 0;
	
	// Ʈ 	
	baud_value = (10 * MCLK/(baudrate * 16));
	if((baud_value % 10) >= 5) baud_value = (baud_value / 10) + 1;
	else                       baud_value /= 10;
	
	// DEBUGU clock enable
	PMC_PCER = 1 << ID_SYS;
	
	PIOA_PDR  = PA10_DTXD | PA9_DRXD;   // Disable PIO
	PIOA_ASR  = PA10_DTXD | PA9_DRXD;   // Enable PeripherialA
	
	DBGU_CR	= US_RSTRX | US_RSTTX;
	DBGU_BRGR 	= baud_value;
	DBGU_MR   	= US_PAR_NONE | US_CHMODE_NORMAL;
	DBGU_CR   	= US_RXEN | US_TXEN;

	// ͷƮ 	
	DBGU_IER    = US_RXRDY;
	
	// ͷƮ ڵ鷯  
	irq_request( ID_SYS, AIC_SRCTYPE_INT_HIGH_LEVEL, console_irq_handler ); // ͷƮ ڵ鷯 
	irq_active( ID_SYS );                   								// ͷƮ 㰡
	
}


//------------------------------------------------------------------------------
//  : ܼ ġ ѹڸ  Ѱ üũ Ѵ.
// ȯ : 0 :  Ұ 
//		0 ƴϸ  
//------------------------------------------------------------------------------
u32 console_write_ok( void )
{
	return DBGU_CSR & US_TXRDY;
}

//------------------------------------------------------------------------------
//  : ܼ ġ ѹڸ Ѵ.
// Ű : c :   
//------------------------------------------------------------------------------
RAMFUNC void console_putc( const u8 c )
{
	while((DBGU_CSR & US_TXRDY) == 0);
	DBGU_THR = c;
}

//------------------------------------------------------------------------------
//  : ŵ ڰ ִ° ȮѴ.
// ȯ : 0 : ŵ ڰ . 
//		0 ƴϸ ŵ ڰ ִ
//------------------------------------------------------------------------------
u32  console_read_ok( void )
{
//	if( DBGU_CSR & US_RXRDY) return 1;
//	return 0;

	return rxq_head != rxq_tail;

}

//------------------------------------------------------------------------------
//  : ŵ ڸ ´. 
// ȯ : ŵ 
//------------------------------------------------------------------------------
u8  console_getc( void )
{
//	return DBGU_RHR;

	u8 c;
	
	c = rxq_buff[rxq_tail];
	rxq_tail++;
	rxq_tail &= RX_QUEUE_MASK;
	
	return c;
}

