//------------------------------------------------------------------------------
//    : esram.c
//       : external SRAM  ó
//    : 뿵(ysroh@suv.ac.kr)
//    : 2007 11 12
//    : 
//    : 
// Your request has been registered with id 228226, 2007.11.22 ATMEL 
//------------------------------------------------------------------------------
#include <typedef.h>
#include <register.h>
#include <setup.h>
#include <main.h>

#include <stdio.h>

#include <etk.h>

#define TST_PAT_O 0xAA55
#define TST_PAT_E 0x55AA

void Ext_SRAM_Init(void);
void Ext_SRAM_Clean(void);

static u32 ext_sram_start = ADDR_ESRAM;		//0x10000000
static u32 ext_sram_end = ADDR_ESRAM_END;	//0x10080000

static u32 ext_sram_size = 0x100; // for test
// static u32 ext_sram_size = ADDR_ESRAM_END - ADDR_ESRAM;		// 0x00080000, 512KBytes


//------------------------------------------------------------------------------
//  : AT91SAM7SExxx register 
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
void Ext_SRAM_Init(void)
{
	u32 sram_flag = 0x0;
	u16 *rptr, *wptr, *ptr_end;
	u16 write_pat_o, write_pat_e, read_pat_o, read_pat_e;

	//--------------------------------------------------------------------------
	// register 
	//--------------------------------------------------------------------------
	
	//-----------------------
	// Clock enable
	//-----------------------
	PMC_PCER = ((1 << ID_PIOA) | (1 << ID_PIOB) | (1 << ID_PIOC)); //clock Ensble

	//-----------------------
	// PIO disable
	//-----------------------
	// NBS1
	PIOA_PDR = NBS1;
	// NBS0(A0), A[1..17]
	PIOB_PDR = ESRAM_A0toA17;
	// D[0..15], A[18..22], NWE, NRD, NCS0
	PIOC_PDR = (ESRAM_D0toD15 | ESRAM_A18toA22 | NWE | NRD | NCS0);

	//-----------------------
	// Peripheral Select
	//-----------------------
	// NBS1
	PIOA_BSR = NBS1;
	// NBS0(A0), A[1..17]
	PIOB_BSR = ESRAM_A0toA17;
	// D[0..15], A[18..22]
	PIOC_ASR = (ESRAM_D0toD15 | ESRAM_A18toA22);
	// NWE, NRD, NCS0
	PIOC_BSR = NWE | NRD | NCS0;

//	EBI_CSA = NCS2 | NCS4 | NCS5 | NCS6;
//	EBI_CSA = NCS0 | NCS2 | NCS4 | NCS5 | NCS6;
	EBI_CSA = 0x00000000; // NCS0 is not defined in EBI_CSA.

  //-----------------------
	// Wait state 
	//-----------------------
	// 6 wait states, Wait state enable, 1 data float time, 16bit wide device, 16bit wide bus
	SMC_CSR0 = (SMC_CSR_NWS_ETK | SMC_CSR_WSEN_ETK | SMC_CSR_TDF_ETK | SMC_CSR_BAT_ETK | SMC_CSR_DBW_ETK);
	

	sram_flag = TRUE;
	
	// Test

	write_pat_o = TST_PAT_O;
	write_pat_e = TST_PAT_E;

 while(1) {  // for test
	rptr = wptr = (u16 *)ext_sram_start;

	u32 tmp = ext_sram_size + ext_sram_start;
	ptr_end = (u16 *)tmp;

	//	ptr_end = ext_sram_end;

	for ( ; ptr_end != wptr; ){
		*wptr++ = write_pat_o;		// write pattern
		*wptr++ = write_pat_e;
		read_pat_o = *rptr++;
		read_pat_e = *rptr++;

		if(DEBUG) printf("DEBUG : Address = %x, Data = %x\n", rptr, *rptr);

	}
 }
}


//------------------------------------------------------------------------------
//  : External SRAM ʱȭ
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
void Ext_SRAM_Clean(void)
{
	

//	return 1;
}
