//------------------------------------------------------------------------------
//    : esram.c
//      : external SRAM  ó
//    : 뿵(ysroh@suv.ac.kr)
//    : 2007 11 12
//    : 
//    : 
//------------------------------------------------------------------------------
#include <typedef.h>
#include <register.h>
#include <setup.h>
#include <main.h>

#include <stdio.h>

#include <etk.h>

#define TST_PAT_O 0xAA55
#define TST_PAT_E 0x55AA
#define ESRAM_INIT_PAT 0x0000

void Ext_SRAM_Init(void);
void Ext_SRAM_Clean(void);


//static u32 ext_sram_start = ADDR_SRAM;		//0x00200000
//static u32 ext_sram_end = ADDR_SRAM_END;	//0x00300000

static u32 ext_sram_start = ADDR_ESRAM;		//0x10000000
static u32 ext_sram_end = ADDR_ESRAM_END;	//0x10080000
static u32 ext_sram_size = ADDR_ESRAM_END - ADDR_ESRAM;		// 0x00080000, 512KBytes
/*
static u32 ext_ncs2_start = 0x30000000;
static u32 ext_ncs4_start = 0x50000000;
static u32 ext_ncs5_start = 0x60000000;
static u32 ext_ncs6_start = 0x70000000;
*/

//------------------------------------------------------------------------------
//  : AT91SAM7SExxx register 
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
void Ext_SRAM_Init(void)
{

	//--------------------------------------------------------------------------
	// register 
	//--------------------------------------------------------------------------
	
	//-----------------------
	// Clock enable
	//-----------------------
	PMC_PCER = ((1 << ID_PIOA) | (1 << ID_PIOB) | (1 << ID_PIOC)); //clock Ensble

	//-----------------------
	// PIO disable
	//-----------------------
	// NBS1
	PIOA_PDR = NBS1;
	// NBS0(A0), A[1..17]
	PIOB_PDR = ESRAM_A0toA17;
	// D[0..15], A[18..22], NWE, NRD, NCS0
	PIOC_PDR = (ESRAM_D0toD15 | ESRAM_A18toA22 | NWE | NRD | NCS0);

	//-----------------------
	// Peripheral Select
	//-----------------------
	// NBS1
	PIOA_BSR = NBS1;
	// NBS0(A0), A[1..17]
	PIOB_BSR = ESRAM_A0toA17;
	// D[0..15], A[18..22]
	PIOC_ASR = (ESRAM_D0toD15 | ESRAM_A18toA22);
	// NWE, NRD, NCS0
	PIOC_BSR = NWE | NRD | NCS0;

	
	//
	// NCS1,2,3,4 for test
	//
	EBI_CSA = (!EBI_CSA_CS1A & !EBI_CSA_CS2A & !EBI_CSA_CS3A & !EBI_CSA_CS4A & !EBI_CSA_NWPC);

	//-----------------------
	// Wait state 
	//-----------------------
	// 3 wait states, Wait state enable, 0 data float time, 16bit wide device, 16bit wide bus
	SMC_CSR2 = (SMC_CSR_NWS_ETK | SMC_CSR_WSEN_ETK | SMC_CSR_TDF_ETK | SMC_CSR_BAT_ETK | SMC_CSR_DBW_ETK);
	SMC_CSR4 = (SMC_CSR_NWS_ETK | SMC_CSR_WSEN_ETK | SMC_CSR_TDF_ETK | SMC_CSR_BAT_ETK | SMC_CSR_DBW_ETK);
	SMC_CSR5 = (SMC_CSR_NWS_ETK | SMC_CSR_WSEN_ETK | SMC_CSR_TDF_ETK | SMC_CSR_BAT_ETK | SMC_CSR_DBW_ETK);
	SMC_CSR6 = (SMC_CSR_NWS_ETK | SMC_CSR_WSEN_ETK | SMC_CSR_TDF_ETK | SMC_CSR_BAT_ETK | SMC_CSR_DBW_ETK);
	// 3 wait states, Wait state enable, 0 data float time, 16bit wide device, 16bit wide bus
	SMC_CSR0 = (SMC_CSR_NWS_ETK | SMC_CSR_WSEN_ETK | SMC_CSR_TDF_ETK | SMC_CSR_BAT_ETK | SMC_CSR_DBW_ETK);
	
/*
	u32 sram_flag = 0x0, tmp;
	u16 *rptr, *wptr, *ptr_end;
	u16 write_pat_o, write_pat_e, read_pat_o, read_pat_e;

	sram_flag = TRUE;
	
	// Test

	write_pat_o = TST_PAT_O;
	write_pat_e = TST_PAT_E;

	rptr = wptr = (u16 *)ext_sram_start;

	u32 tmp = ext_sram_size + ext_sram_start;
	ptr_end = (u16 *)tmp;
		
	for ( ; ptr_end != wptr; ){
		*wptr++ = write_pat_e;
		read_pat_o = *rptr++;
		*wptr++ = write_pat_o;		// write pattern
		read_pat_e = *rptr++;
//		if(DEBUG) printf("DEBUG : Address = %x, Data = %x\n", rptr, *rptr);
	}
*/

	if(DEBUG) printf("DEBUG : DONE, External SRAM, Initialization\r\n");

}


//------------------------------------------------------------------------------
//  : External SRAM ʱȭ
// Ű : 
// ȯ :  
//  : 
//------------------------------------------------------------------------------
void Ext_SRAM_Clean(void)
{
	u16 *ptr, *ptr_end;

	ptr = (u16 *)ext_sram_start;
	ptr_end = (u16 *)(ext_sram_size + ext_sram_start);

	for ( ; ptr_end != ptr; ) 		*ptr++ = ESRAM_INIT_PAT;
	if(DEBUG) printf("DEBUG : DONE, External SRAM, Cleaning\r\n");
}
