//------------------------------------------------------------------------------

//    : etk.h
//      : Embedded Training Kit (ETK)  Լ
//    : 뿵(ysroh@suv.ac.kr)
//    : 2007 11 12
//    : 

//      :  
//------------------------------------------------------------------------------
#ifndef _ETK_HEADER_
#define _ETK_HEADER_

#ifndef __ASSEMBLY__
extern void Ext_SRAM_Init(void);
extern void Ext_SRAM_Clean(void);
#endif

#define Ext_SRAM_Addr_A0toA17		(0x3ffff	<<	0)		// Address = A0 ~ A17
#define Ext_SRAM_Addr_A18toA22		(0x1f	<<  16)		// Address = A18 ~ A22

//LEDs
#define LED1				(1<<0)	//(PIO_PA0)   //Because Assembler.....
#define LED2				(1<<1)	//(PIO_PA1)
#define LED3				(1<<2)	//(PIO_PA2)

#define PWM0			(PA0_PWM0)
#define PWM1			(PA1_PWM1)
#define PWM2			(PA2_PWM2)

//EEPROM
#define TWD				(PA3_TWD)
#define TWCK			(PA4_TWCK)

//Serial Port
#define RXD0				(PA5_RXD0)
#define TXD0				(PA6_TXD0)
#define RTS0				(PA7_RTS0)
#define CTS0				(PA8_CTS0)

//Debug Serial Port
#define DRXD				(PA9_DRXD)
#define DTXD				(PA10_DTXD)

#ifdef _AT91SAM7S_
#define VBUS_DET		(PIO_PA13)
#else
#define VBUS_DET		(PIO_PC19)
#endif

//USB_DP Pull-Up
#define USB_DP_PU		(PIO_PA16)

//LCD
#ifdef _AT91SAM7S_
#define LCD_EN			(PIO_PA11)
#define LCD_RW			(PIO_PA12)
#define LCD_RS			(PIO_PA14)
#define LCD_D4			(PIO_PA17)
#define LCD_D5			(PIO_PA18)
#define LCD_D6			(PIO_PA19)
#define LCD_D7			(PIO_PA20)
#else
#define LCD_EN			(PIO_PB27)
#define LCD_RW			(PIO_PB25)
#define LCD_RS			(PIO_PB24)
#define LCD_D4			(PIO_PB28)
#define LCD_D5			(PIO_PB29)
#define LCD_D6			(PIO_PB30)
#define LCD_D7			(PIO_PB31)
#endif

//IR Recever
#ifdef _AT91SAM7S_
#define TIOA1_IR		(PIO_PA15)
#else 
#define TIOA1_IR		(PIO_PB26)
#endif

//External Interrupt
#ifdef _AT91SAM7S_
#define EXT_FIQ			(PIO_PA19)
#define EXT_IRQ			(PIO_PA20)
#else 
#define EXT_FIQ			(PIO_PB19)
#define EXT_IRQ			(PIO_PB20)
#endif

//7-Segment
#ifdef _AT91SAM7S_
#define SEV_SEG_LATCH	(PIO_PA21)
#define SHIFT_CLOCK		(PIO_PA22)
#define SHIFT_DATA		(PIO_PA23)
#else 
#define SEV_SEG_LATCH	(PIO_PB21)
#define SHIFT_CLOCK		(PIO_PB22)
#define SHIFT_DATA		(PIO_PB23)
#endif

//Key Matrix
#define RTN0			(PIO_PA24)
#define RTN1			(PIO_PA25)
#define RTN2			(PIO_PA26)
#define RTN3			(PIO_PA27)
#define SCAN0			(PIO_PA28)
#define SCAN1			(PIO_PA29)
#define SCAN2			(PIO_PA30)
#define SCAN3			(PIO_PA31)

//Jtag
#define nICERST			(PIO_PA21)
#define DBGACK			(PIO_PA22)
#define DBGRQ			(PIO_PA23)
#define nSRST			(PIO_PA24)
#define RTCK			(PIO_PA25)
#define TDO				(PIO_PA26)
#define TCK				(PIO_PA27)
#define TMS				(PIO_PA28)
#define TDI				(PIO_PA29)
#define nTRST			(PIO_PA30)

//SRAM
#define NWE				(PC21_NWR0_NWE_CFWE)
#define NRD				(PC22_NRD_CFOE)
#define NCS0			(PC23_NCS0)
#define NCS1			(PA26_NCS1_SDCS)
#define NCS2			(PA20_NCS2_CFCS1)
#define NCS3			(PC15_NCS3_NANDCS)
#define NCS4			(PA19_NCS4_CFCS0)
#define NCS5			(PA22_NCS5_CFCE1)
#define NCS6			(PA21_NCS6_CFCE2)
#define NCS7			(PC20_NCS7)

//External Address
#ifndef _AT91SAM7S_
#define NBS1			(PIO_PA23)
#endif

#define ESRAM_A0toA17	(0x3ff	<<	0)		// Address = A0 ~ A17
#define A0				(PB0_A0_NBS0)
#define A1				(PB1_A1_NBS2)
#define A2				(PB2_A2)
#define A3				(PB3_A3)
#define A4				(PB4_A4)
#define A5				(PB5_A5)
#define A6				(PB6_A6)
#define A7				(PB7_A7)
#define A8				(PB8_A8)
#define A9				(PB9_A9)
#define A10				(PB10_A10)
#define A11				(PB11_A11)
#define A12				(PB12_A12)
#define A13				(PB13_A13)
#define A14				(PB14_A14)
#define A15				(PB15_A15)
#define A16				(PB16_A16_BA0)
#define A17				(PB17_A17_BA1)

#define ESRAM_A18toA22	(0x1f	<<  16)		// Address = A18 ~ A22
#define A18				(PC16_A18)
#define A19				(PC17_A19)
#define A20				(PC18_A20)
#define A21				(PC19_A21)
#define A22				(PC20_A22)

//External Data
#define ESRAM_D0toD15	(0xffff	<< 0)		// data = d0 ~ d15
#define D0				(PC0_D0)
#define D1				(PC1_D1)
#define D2				(PC2_D2)
#define D3				(PC3_D3)
#define D4				(PC4_D4)
#define D5				(PC5_D5)
#define D6				(PC6_D6)
#define D7				(PC7_D7)
#define D8				(PC8_D8)
#define D9				(PC9_D9)
#define D10				(PC10_D10)
#define D11				(PC11_D11)
#define D12				(PC12_D12)
#define D13				(PC13_D13)
#define D14				(PC14_D14)
#define D15				(PC15_D15)


//------------------------------------------
// Register bit definition
//------------------------------------------

#define ADDR_ESRAM				0x10000000
#define ADDR_ESRAM_END			0x10080000  //512Kbytes

#define SMC_CSR_NWS_ETK				(0x02 	<<  0)		// Number of wait states, 3 wait states, 1 ~ 128 wait states
#define SMC_CSR_WSEN_ETK			(0x01	<<	7)		// Wait state enable - 1 wait state, 0 wait state if disable
#define SMC_CSR_TDF_ETK				(0x00	<<	8)		// Data float time, 1 cycle float, 0 ~ 15 cycles
#define SMC_CSR_BAT_ETK				(0x01	<<	12)		// Byte access type, 0 for two 8-bit wide device, 1 for a 16-bit wide device
#define SMC_CSR_DBW_ETK				(0x01	<<	13)		// Data bus width, 01b for 16-bit, 10b for 8-bit
#define SMC_CSR_DRP_ETK				(0x00	<<	15)		// Data read protocol, 0 for Standard, 1 for Early read protocol

#define SMC_CSR_ACSS_ETK			(0x01	<<	16)		// Address to chip select setup
#define SMC_CSR_RWSETUP_ETK			(0x01	<<	24)		// Read and Write signal setup time
#define SMC_CSR_RWHOLD_ETK			(0x01	<<	28)		// Read and write signal hold time

#define ESRAM_A0toA17				(0x3ff	<<	0)		// Address = A0 ~ A17
#define ESRAM_A18toA22				(0x1f	<<  16)		// Address = A18 ~ A22

#endif
